// --------------------------------------------------------------------------
// gMini,
// a minimal Glut/OpenGL app to extend
//
// Copyright(C) 2007-2009
// Tamy Boubekeur
//
// All rights reserved.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License (http://www.gnu.org/licenses/gpl.txt)
// for more details.
//
// --------------------------------------------------------------------------

uniform float diffuseRef;
uniform float specRef;
uniform float shininess;
//uniform bool draw_mode;

varying vec4 P;
varying vec3 N;
varying vec4 color;
varying float weight;

void main (void) {
    vec3 p = vec3 (gl_ModelViewMatrix * P);
    vec3 n = normalize (gl_NormalMatrix * N);
    vec3 v = normalize (-p);
    vec4 weighted_color = 0.85*color; // 0.85
    vec4 no_weight_color = 0.25 * (n.y*vec4 (1.0, 0.98, 0.66, 1)
                                   + (1.0-n.y)*(0.01, 0.2, 0.55));
//   vec4 no_weight_color =  vec4(0.0, 0.0, 0.0, 1);
    //gl_FragColor = vec4(0.,0.,0.,1.);
    for (int i = 0; i < 3; i++) {
        if(i != 1 ){
            vec3 l = normalize (vec3(0.,0.,0.) - p);
            float diffuse   = max (dot (l, n), 0.0);
            vec3 r = reflect (-l, n);

            float spec = max(dot(r, v), 0.0);
            spec = pow (spec, shininess);
            spec = max (0.0, spec);

//            vec4 LightContribution =
//                    diffuseRef * diffuse * gl_LightSource[i].diffuse +
//                    specRef * spec * gl_LightSource[i].specular;
            vec4 LightContribution =
                    diffuseRef * diffuse * gl_LightSource[i].diffuse  +
                    specRef * spec * gl_LightSource[i].specular;
            weighted_color += 0.45*vec4 (LightContribution.xyz, 1); // 0.25
            no_weight_color+= 0.45*vec4 (LightContribution.xyz, 1); //0.75
        }
    }
    gl_FragColor = weight*weighted_color + (1-weight)*no_weight_color;

//    if(draw_mode){
//        gl_FragColor = weighted_color;

    //Si tu veux du bleu
    //gl_FragColor = weighted_color;
}

